function verf_mit_spline_ohnekom(fh,g,x,u,h,delta,beta,zeta,theta,grenze_kn,x_vgl,v_vgl,problem);

% Berechnet Optimalwertfunktion von eindimensionalen optimalen 
% Steuerungsproblemen mit MATLAB-Spline-Interpolationsroutine
% auf adaptiven Gittern
%
% In jeder Iteration wird die maximale Differenz zwischen der aktuellen
% und der vorherigen Approximation sowie die Anzahl der momentanen Knoten ausgegeben,
% sowie nach jeder Hauptiteration (d.h. auf dem aktuellen Gitter ist die optimale Wertefunktion bestimmt)
% eine obere Grenze fuer den Fehler auf dem gesamten betrachteten Bereich [x_1,x_n]

z_iter  =   0;                                              

% Festlegung der vom betrachteten Problem unabhaengigen Parameter

grenze_iter     =   3000;               

plotintervall   =   200;                

% Festlegung der vom betrachteten Problem abhaengigen Parameter und Funktionen

beta    =   1-delta*h;                      

% Vorbesetzung der Vektoren:

ff   = zeros(length(x),length(u));
gg   = zeros(length(x),length(u));
uopt = ones(1,length(x));
v    = zeros(length(x),1);

abbruch = 0;                            

 
% Durchlaufe Schleife solange bis ein Abbruchkriterium erfuellt ist

while(abbruch==0)

    for i=1:length(x)
        for k=1:length(u)
            ff(i,k) = feval(fh,x(i),u(k),h);                
            gg(i,k) = feval(g,x(i),u(k));  
        end
    end

    zetamax = 2*zeta;
      
    while(zetamax>zeta)                                     
                                                            
       z_iter=z_iter+1;                                    
         
       ss=spline(x,v);                                     
       v2=v;       
       
           for i=1:length(x)
           
              for k=1:length(u)
                  if ff(i,k)>=x(1) & ff(i,k)<=x(length(x))              
                      ss2(k)=ppval(ss,ff(i,k));                        
                      t(k)=h*gg(i,k)+beta*ss2(k);                       
                  else                                          
                      t(k)=-1e+5;                                      
                  end
              end
              
              v(i)=max(t);                                   
    
              for j=1:length(t)                              
                  if t(j)==max(t)                            
                     uopt(i)=u(j);
                  end
              end
           
              clear t;
              clear ss2;
           end;
       
       zeta2=v-v2;                                             
       zetamax=max(abs(zeta2));                                
       
       fprintf('\nmax. Schritt: %f      %d      %d',zetamax,length(x),z_iter);     

       maxschritt(z_iter)=zetamax;                            
        
       if z_iter>=grenze_iter                                   
           grenze_knoten=1;                                    
           break;                                              
       end
       
       if problem(1:2)=='wm'                                                                 
            if mod(z_iter,plotintervall)==0                                             
                xhilf2 = x(1):(x(length(x))-x(1))/3000:x(length(x));                   
                for i=1:length(xhilf2)                                                 
                        vhilf2(i)=ppval(ss,xhilf2(i));                                 
                end                                                                    
                figure;                                                                 
                plot(xhilf2,vhilf2,x,v,'o',x,exakt_wm(x));                             
                title('Entwicklung der Approximation');                                 
            end                                                                            
       else if mod(z_iter,plotintervall)==0                                             
                xhilf2 = x(1):(x(length(x))-x(1))/3000:x(length(x));                   
                for i=1:length(xhilf2)                                                  
                        vhilf2(i)=ppval(ss,xhilf2(i));                                 
                end                                                                    
                figure;                                                                 
                plot(xhilf2,vhilf2,x,v,'o',x_vgl, v_vgl,'r'); 
                title('Entwicklung der Approximation');
            end
       end                                                                               
       
   end                                                      
   
    figure;                                                                                
    plot(x,v,x_vgl, v_vgl,'r');                              
    title('Approximation vor Gitteradaption');
    
    abbruch=1;                                               
    
    if problem(1:2)=='wm'                                        
        
        ss=spline(x,v);                                      
        
        z3=1;                                              
           
        for i=1:length(x_vgl)                               
            vhilf3(i)=ppval(ss,x_vgl(i));                   
        end
        
        maxfehl(z3)=max(abs(vhilf3-v_vgl));       
  
        fprintf('      max. Fehler=    %d',maxfehl(z3));     
        z3=z3+1;
     end
    
% Gitterveraenderung
     
    ss=spline(x,v);                                           

    for i=1:length(x)-1                              
        xx(i)=((x(i+1)+x(i))/2);                              
        vv(i)=ppval(ss,xx(i));                                 
     end
    
    for i=1:length(xx)
        for k=1:length(u)
            ff2(i,k) = feval(fh,xx(i),u(k),h);                
            gg2(i,k) = feval(g,xx(i),u(k));                    
         end;
     end;
       
    for i=1:length(xx)
    
        for k=1:length(u)
                  if ff2(i,k)>=x(1) & ff2(i,k)<=x(length(x))              
                      t2(k)=(h*gg2(i,k)+beta.*ppval(ss,ff2(i,k)));        
                  else                                                    
                      t2(k)=-1e+5;                                      
                   end
         end
    
        vtest(i)=max(t2);                                                              
        clear t2;                                              
     end                                                         
    
    for i=1:length(xx)                                         
         eta(i)=abs(vtest(i)-vv(i));                            
     end                                                         
                                                                
    maxeta=max(eta);                                            

    fprintf('        eta: %f   ',maxeta);                                       
    fprintf('        Gesamtfehlerschranke: %f    ',maxeta*(1/(1-beta)));       
    
    figure;                                                     
    plot(xx,eta,'o');                                           
    title('lokaler Fehler in den einzelnen Intervallen');
    
    % neue Knotenpunkte (gespeichert im Vektor xneu):

    if(length(x)<grenze_kn)                                     
                                                                
        z2=1;                                                   
        
        for i=1:length(xx)                                      
             if eta(i)>theta*maxeta                              
               xneu(z2)=xx(i);                                 
               vneu(z2)=vv(i);                                  
               z2=z2+1;
             end
         end

        xhilf=x;                                                
        vhilf=v;    
    
        [x,v]=vektsort(xhilf,vhilf,xneu,vneu);                   
        clear xneu;
        clear vneu;
     
        if maxeta>zeta/(1/(1-beta))                              
            abbruch = 0;                                         
            clear uopt;                                          
         end                                                     
     end                                                          

 end                                                              

% Veranschaulicheung der errechneten Ergebnisse

intlaengen=diff(x);                                              
intlaengen(length(x))=intlaengen(length(x)-1);                   

erstelle_graphen(x, v, uopt, intlaengen, x_vgl, v_vgl,maxschritt);         
                                                                 
