function verf_mit_splinestrategie(fh,g,x,u,h,delta,beta,zeta,theta,grenze_kn,mindest_gleich,x_vgl,v_vgl,problem);


% Berechnet Loesung mit MATLAB-Spline-Interpolationsroutine
% auf adaptivem Gitter unter Anwendung der Strategie-Iteration
%
% Der Aufbau entspricht zum groessten Teil dem des Programms
% 'iterationsverfahren_mit_spline.m'
% Aus diesem Grund sind nur die neu hinzugekommenen Passagen
% kommentiert.

z_iter=0;                               
z1=0;                                   
% Zaehler zur Ueberpruefung der "Konvergenz" der optimalen Kontrollwerte

grenze_iter = 3000;

maxim=1;                                
% Wenn maxim=1, wird eine urpruengliche Iteration durchgefuehrt
testu=1;                                
% Wenn testu=1, werden die opt. Kontrollen auf der aktuellen
% und der letzten Iteration verglichen.

% Vorbesetzung der Vektoren 

v   = zeros(length(x),1);
ff  = zeros(length(x),length(u));
gg  = zeros(length(x),length(u));
uopt= ones(1,length(x));

abbruch=0;
abbruch2=0;

% Durchlaufe Schleife

while(abbruch==0)

    for i=1:length(x)
        for k=1:length(u)
            ff(i,k) = feval(fh,x(i),u(k),h);          
            gg(i,k) = feval(g,x(i),u(k));                
        end
    end

    zetamax = 2*zeta;
    uopt2=ones(1,length(x)); 
    
    while(zetamax>zeta) 
    
    while(zetamax>zeta)                               
    
       z_iter=z_iter+1;
       ss=spline(x,v);                                   
       v2=v;
          
       if maxim==1                                         
           for i=1:length(x)
           
              for k=1:length(u)
                  if ff(i,k)>=x(1) & ff(i,k)<=x(length(x))
                      ss2(k)=ppval(ss,ff(i,k));                
                      t(k)=h*gg(i,k)+beta*ss2(k);              
                  else
                      t(k)=-1e-5;
                  end
              end
         
              v(i)=max(t);
 
              for j=1:length(t)            
                  if t(j)==max(t)
                     uopt(i)=u(j);
                     indexuopt(i)=j;
                     % Speicherung des Index' des opt. Kontrollwertes
                  end
              end
              
              clear t;
              clear ss2;
              testu=1;
           end;
        
       else                                
       % Strategie-Iteration bei "Konvergenz" der optimalen Kontrollwerte
       % zu dem optimalen Vektor uopt wird t bestimmt;
       % somit faellt die Optimierung weg
           for r=1:length(x)                                                       
               F(r,1)=ppval(ss,ff(r,indexuopt(r)));               
           end
           
           for q=1:length(x)
               G(q,1)=h*gg(q,indexuopt(q));
           end
           
           t3=G+beta*F;
           v=t3;
           testu=2;
           maxim=0;
       end   

       if testu==1;                        % Testen der "Konvergenz" der optimalen Kontrollwerte                               
           for k=1:length(uopt)
               if uopt(k)==uopt2(k)        % Die optimalen Kontrollen der aktuellen und die der
                   z1=z1+1;                % letzten Iteration werden verglichen
               end
           end
                   
           uopt2=uopt;
           if z1>=mindest_gleich*length(x); % Ist der Anteil groesser als mindest_gleich, wird in der
               maxim=0;                     % naechsten Iteration zur Strategie-Iteration gewechselt.
           end
       end
    
       z3=0;
       zeta2=v-v2;                           
       zetamax=max(abs(zeta2)); 
       
       fprintf('\nmax. Schritt: %f      %d       %d    %4.2f  ',zetamax,length(x),z_iter, z1/length(x));
       % Prozentteil der Uebereinstimmungen wird zusaetzlich ausgegeben
       z1=0;
       maxschritt(z_iter)=zetamax;
       
       clear F;
       clear G;
       
       if testu==2          % Wenn eine Strategie-Iteraion sttgefunden hat wird ein Kennzeichen ausgegeben.
            fprintf('o');   % (dient lediglich zur Ueberpruefung)
       end
       
       if z_iter>grenze_iter  % Ist die Hoechstanzahl an Iterationen ueberschritten wird
           abbruch2=1;        % abbruch2 gleich 1 gesetzt. Der Algorithmus wird abgebrochen.
           break;
       end
       
    end  % Ende der innersten While-Schleife
    
    if testu==2             % Wurde eine Strategie-Iteration durchgefuehrt, wird wieder zum
        zetamax=2*zeta;     % urspruenglichen Verfahren zuruechgekehrt. Dazu muss zetamax wieder
    end                     % erhoeht werden, sonst wuerde eine Gitteradaption folgen.
    
    maxim=1;
    clear indexuopt;
    
    if abbruch2==1
        break;
    end
    
    end  % Ende der mittleren While-Schleife
    
    abbruch=1;

    if problem(1:2)=='wm'                                                  
        
        ss=spline(x,v);
     
        for i=1:length(x_vgl)                                   
            vhilf3(i)=ppval(ss,x_vgl(i));                           
        end
 
        maxfehl=max(abs(vhilf3-v_vgl));
        fprintf('       max. Fehler=    %f', maxfehl);               
       
    end
    
    % Gitterveraenderung
   
    ss=spline(x,v);

    for i=1:length(x)-1                              
        xx(i)=((x(i+1)+x(i))/2);                         
        vv(i)=ppval(ss,xx(i));                                 
                                                               
    end
    
    for i=1:length(xx)
        for k=1:length(u)
            ff2(i,k) = feval(fh,xx(i),u(k),h);                
            gg2(i,k) = feval(g,xx(i),u(k));                    
        end;
    end;
       
    for i=1:length(xx)   
        for k=1:length(u)
                  if ff2(i,k)>=x(1) & ff2(i,k)<=x(length(x))       
                      t2(k)=(h*gg2(i,k)+beta.*ppval(ss,ff2(i,k)));
                  else
                      t2(k)=-1e+5;
                  end
        end
    
    vtest(i)=max(t2);
    clear t2;
    
    end
    
    for i=1:length(xx)                    
        eta(i)=abs(vtest(i)-vv(i));
    end

    maxeta=max(eta);

    fprintf('      eta: %f    ',maxeta);                                    
    fprintf('      Gesamtfehlerschranke: %f    ',maxeta*(1/(1-beta)));      
    
    % neue Knotenpunkte:
    
    if abbruch==2
        break;
    end
    if(length(x)<grenze_kn)
        
      z2=1;
      for i=1:length(xx)                                        
          if eta(i)>theta*maxeta
             xneu(z2)=xx(i);
             vneu(z2)=vv(i);
             z2=z2+1;
          end
      end
    
      xhilf=x;                                                
      vhilf=v;    
    
      [x,v]=vektsort(xhilf,vhilf,xneu,vneu);                  
     
      clear xneu;
      clear vneu;
    
      if maxeta>zeta/(1/(1-beta))                              
         abbruch = 0;                                           
         clear uopt;                                             
      end
      maxim=1;                                                   
   end

end

% Veranschaulichung der errechneten Ergebnisse:

intlaengen=diff(x);                                             

intlaengen(length(x))=intlaengen(length(x)-1);                   

erstelle_graphen(x, v, uopt, intlaengen, x_vgl, v_vgl, maxschritt);          
